<?php

include_once "WXBizMsgCrypt.php";

// 小鹅平台发送给第三方平台
$encodingAesKey = "abcdefghijklmnopqrstuvwxyz0a23456S89AsCDEFa";    //加密密钥
$token = "pamtest"; //加密令牌

$timeStamp = "1409304348";  //时间戳
$nonce = "xxxxxx";          //随机数
$appId = "appXfxxxxxxxx";   //app_id

$xml = '<xml><type>user_register</type><app_id>appQBc9nDNy5840</app_id><title>我是title</title><content>我是content</content><xml>';

$pc = new WXBizMsgCrypt($token, $encodingAesKey, $appId);
$encryptMsg = '';
$errCode = $pc->encryptMsg($xml, $timeStamp, $nonce, $encryptMsg);

if ($errCode == 0) {
	print("加密后: " . $encryptMsg . "\n");
} else {
	print($errCode . "\n");
}

$xml_tree = new DOMDocument();
$xml_tree->loadXML($encryptMsg);
//获取XML中的数据
$array_e = $xml_tree->getElementsByTagName('Encrypt');
$array_m = $xml_tree->getElementsByTagName('MsgSignature');
$array_t = $xml_tree->getElementsByTagName('TimeStamp');
$array_n = $xml_tree->getElementsByTagName('Nonce');

$encrypt = $array_e->item(0)->nodeValue;    //加密字符串
$msg_sign = $array_m->item(0)->nodeValue;   //消息体签名
$timeStamp = $array_t->item(0)->nodeValue;  //时间戳
$nonce = $array_n->item(0)->nodeValue;  //随机数


$format = "<xml><Encrypt><![CDATA[%s]]></Encrypt></xml>";
$from_xml = sprintf($format, $encrypt);

$msg = '';
$errCode = $pc->decryptMsg($msg_sign, $timeStamp, $nonce, $from_xml, $msg);
if ($errCode == 0) {
	print("解密后: " . $msg . "\n");
} else {
	print($errCode . "\n");
}



